#ifndef _Euclid
#define _Euclid

#include <cassert>

class Euclid {
private:
    long _a, _b, _result;
    inline long _compute(long, long) const;
public:
    inline Euclid(long, long);
    inline long result() const;
};

long Euclid::_compute(long a, long b) const {
    if (b == 0L) return a;
    return _compute(b, a % b);
}

Euclid::Euclid(long a, long b) : _a(a), _b(b), _result(0L) {
    assert(_a >= 0L && _b > 0L);
    _result = _compute(_a, _b);
}

long Euclid::result() const {
    return _result;
}

#endif
